from solver import *
import copy
class Cell:
    def __init__(self,size,x,y):
        self.couldContain=[True]*size
        self.constraints=[]
        self.x=x
        self.y=y
    def value(self):
        x = [i for i in range(len(self.couldContain)) if self.couldContain[i]]
        if len(x) == 1:
            return x[0]+1
        else:
            return 0
        

        
class ConstraintRegion:
    def __init__(self,cells,p):
        for c in cells:
            c.constraints.append(self)
        self.cells=cells
        self.puzzle=p
        self.grid_2=p.grid_2
        
    def analyze(self):
        possibles=[[0]*self.grid_2 for i in range(self.grid_2)]
        nposs=[0]*self.grid_2
        for i in range(self.grid_2):
            for j in range(self.grid_2):
                if self.cells[i].couldContain[j]:
                    possibles[i][nposs[i]]=j
                    nposs[i]=nposs[i]+1
        self.examine(possibles,nposs,False)
        nposs=[0]*self.grid_2
        for i in range(self.grid_2):
            for j in range(self.grid_2):
                if self.cells[j].couldContain[i]:
                    possibles[i][nposs[i]]=j
                    nposs[i]=nposs[i]+1
        self.examine(possibles,nposs,True)
        
    def examine(self, possibles, nposs, orient):
        for i in range(self.grid_2):
            self.points = [False]*self.grid_2
            self.examined = [False]*self.grid_2
            self.examine_rec(possibles,nposs,i,orient,0)
        del self.points
        del self.examined
        
    def examine_rec(self, possibles,nposs,start,orient,needed):
        if needed+start>=self.grid_2:
            return 0
        needed = needed-1
        for i in range(start,self.grid_2):
            oldneeded=needed
            oldpoints=copy.copy(self.points)
            for j in range(0,nposs[i]):
                if not self.points[possibles[i][j]]:
                    self.points[possibles[i][j]]=True
                    needed=needed+1
            self.examined[i]=True
            if needed == 0:
                for j in range(self.grid_2):
                    if not self.points[j]: continue
                    for k in range(self.grid_2):
                        if self.examined[k]:continue
                        if orient:
                            self.clear(self.cells[j],k)
                        else:
                            self.clear(self.cells[k],j)
                self.examined[i]=False
                self.points=oldpoints
                return 0
            self.examine_rec(possibles,nposs,i+1,orient,needed)
            self.examined[i]=False
            self.points=oldpoints
            needed=oldneeded
        return 0
    
    def clear(self,c,x):
        if c.couldContain[x]:
            c.couldContain[x] = False
            self.puzzle.update(c)

