from xml.sax import *
class FileHandler(ContentHandler):
    def __init__(self,app):
        self.app=app
        self.data=[]
        self.filename=None

    def openfile(self):
        self.data=[]
        self.el_sudoku=False
        self.el_shape=False
        self.el_grid=False
        self.el_data=False
        self.el_line=False
        self.app.shape=[]
        parse(self.filename,self)
    def require(self,vars):
        for i in vars:
            if not i:
                print "unparsed"
                raise ValueError

    def startElement(self,name,attrs):
        if name=="sudoku":
            self.el_sudoku=True
        elif name=="shape":
            self.require((self.el_sudoku,not self.el_shape))
            self.el_shape=True
            self.app.shapex=int(attrs.getValue("xsize"))
            self.app.shapey=int(attrs.getValue("ysize"))
            self.el_shape=True
        elif name=="grid":
            self.require((self.el_sudoku,self.el_shape))
            self.el_grid=True
            self.app.shape.append([int(attrs.getValue("x")),int(attrs.getValue("y"))])
        elif name=="data":
            self.require((self.el_sudoku,not self.el_shape,not self.el_data))
            self.el_data=True
        elif name=="line":
            self.require((self.el_sudoku,self.el_data))
            self.el_line=True
            self.data.append(attrs.getValue("data"))
    def endElement(self,name):
        if name=="sudoku":
            if self.app.shape == []: raise ValueError
            self.app.shape_changed()
            for y in range(len(self.data)):
                for x in range(0,len(self.data[y]),2):
                    if not self.app.used[x/2][y]:continue
                    self.app.entries[x/2][y].set_text(self.app.parsetext(int(self.data[y][x:x+2])))
            self.app.undoes=[]
            self.app.redoes=[]
            self.app.changed=False
            self.app.undo_action.set_sensitive(False)
            self.app.redo_action.set_sensitive(False)
        elif name=="shape":
            self.require((self.el_grid,self.el_shape))
            self.el_shape=False
        elif name=="data":
            self.require((self.el_line,self.el_data))
            self.el_data=False


    def save(self):
        data=[
            '<sudoku>\n',
            '<shape xsize="'+str(self.app.shapex)+'" ysize="'+str(self.app.shapey)+'">\n'
            ]+['<grid x="'+str(x)+'" y="'+str(y)+'"/>\n' for x,y in self.app.shape]+[
            '</shape>\n',
            '<data>\n',
            ]

        data+=['<line data="'+
               "".join([self.app.grabtext(self.app.entries[x][y].get_text())
                        for x in range(self.app.shapewidth) if self.app.used[x][y]])+'"/>\n'
               for y in range(self.app.shapeheight)]
        data+=['</data>\n</sudoku>\n']
        f = file(self.filename, "w")
        f.writelines(data)
        f.close()

