#!/usr/bin/env python

# This is my first non-trival program in Python, so I have to say
#               *** PYTHON rOXX0rS!!! ***
# Sorry.

import pygtk
pygtk.require('2.0')
from gtk import *
from files import FileHandler
import gobject

import sys


from xml.sax import *

from solver import *


def colourWidget(a,b):
    ev = EventBox()
    ev.add(a)
    ev.modify_bg(STATE_NORMAL,ev.get_colormap().alloc_color(b))
    return ev

class NewDialog(Dialog):
    articles=[]
    def __init__(self,parent):
        Dialog.__init__(self,"New Su Doku",parent,DIALOG_MODAL,
                        (STOCK_CANCEL,RESPONSE_CANCEL,STOCK_OK,RESPONSE_OK))
        self.vbox.pack_start(Label("Su Doku shape:"))
        self.set_size_request(300,400)
        standard = RadioButton(None, "Standard Su Doku")
        samurai = RadioButton(standard, "Samurai Su Doku")
        custom = RadioButton(standard, "Custom shape")
        customFrame = Frame()
        customControls = Table(8,2,True)
        customControls.set_border_width(10)
        customControls.attach(custom,0,2,0,1)
        
        customControls.attach(Label("Minigrid width:"),0,1,1,2)
        xvaladj=Adjustment(2,2,10,1)
        self.xval=SpinButton(xvaladj)
        customControls.attach(self.xval,1,2,1,2)

        customControls.attach(Label("Minigrid height:"),0,1,2,3)
        yvaladj=Adjustment(2,2,10,1)
        self.yval=SpinButton(yvaladj)
        customControls.attach(self.yval,1,2,2,3)

        customFrame.add(customControls)
        self.vbox.pack_start(standard)
        self.vbox.pack_start(samurai)
        self.vbox.pack_start(customFrame)
        customControls.attach(Label("Locations"),0,1,3,4)
        sw = ScrolledWindow()
        sw.set_shadow_type(SHADOW_ETCHED_IN)
        sw.set_policy(POLICY_AUTOMATIC, POLICY_AUTOMATIC)
        customControls.attach(sw,0,2,4,7)

        model = ListStore(
            gobject.TYPE_INT,
            gobject.TYPE_INT
        )


        treeview = TreeView(model)
        treeview.set_rules_hint(True)
        treeview.get_selection().set_mode(SELECTION_SINGLE)

        model = treeview.get_model()

        renderer=[]
        for col,i in [("X",0), ("Y",1)]:
            renderer.append(CellRendererText())
            renderer[i].set_property("editable",True)
            renderer[i].connect("edited", self.on_cell_edited, model)
            renderer[i].set_data("column", i)
            
            column = TreeViewColumn(col, renderer[i], text=i)
            column.set_sizing(TREE_VIEW_COLUMN_FIXED)
            column.set_fixed_width(100)
            treeview.append_column(column)


        def update_digits(widget, col):
            treeiter = model.get_iter_first()
            while treeiter != None:
                val, = model.get(treeiter, col)
                self.on_cell_edited(renderer[col], str(model.get_string_from_iter(treeiter)), str(val),model)
                treeiter = model.iter_next(treeiter)
        xvaladj.connect("value_changed", update_digits, 0)
        yvaladj.connect("value_changed", update_digits, 1)

        sw.add(treeview)

        button1 = Button("Add item")
        button1.connect("clicked", self.on_add_item_clicked, model)
        customControls.attach(button1,0,1,7,8)
        self.on_add_item_clicked(button1,model)

        button2 = Button("Remove item")
        button2.connect("clicked", self.on_remove_item_clicked, treeview)
        customControls.attach(button2,1,2,7,8)
        
        def allow(e,b):
            for item in (self.xval,self.yval,button1,button2,sw):
                item.set_sensitive(b)
            self.show_all()
        custom.connect("clicked", allow, True)
        standard.connect("clicked", allow, False)
        samurai.connect("clicked", allow, False)
        allow(None, False)
        
        self.show_all()
        if self.run() == RESPONSE_OK:
            if standard.state == 1:
                parent.shapex=parent.shapey=3
                parent.shape=[[0,0]]
            elif samurai.state == 1:
                parent.shapex=parent.shapey=3
                parent.shape=[
                    [0,0],
                    [0,12],
                    [12,0],
                    [6,6],
                    [12,12]
                ]
            else:
                parent.shapex=int(self.xval.get_text())
                parent.shapey=int(self.yval.get_text())
                parent.shape=self.articles

            parent.shape_changed()
        self.destroy()
    
    def on_add_item_clicked(self, button, model):
        new_item = [0, 0]
        self.articles.append(new_item)
        iter = model.append()
        model.set (iter,
            0, new_item[0],
            1, new_item[1],
        )

    def on_remove_item_clicked(self, button, treeview):
        if len(self.articles) == 1: return
        selection = treeview.get_selection()
        model, iter = selection.get_selected()
        if iter:
            path = model.get_path(iter)[0]
            model.remove(iter)
            del self.articles[ path ]


    def on_cell_edited(self, cell, path_string, new_text, model):
        iter = model.get_iter_from_string(path_string)
        column = cell.get_data("column")
        path = model.get_path(iter)[0]
        size = [self.xval,self.yval][column].get_text()
        self.articles[path][column] = int(round(min(int(new_text),20)/float(size)))*int(size)
        if self.articles[path][column]>20:self.articles[path][column]-=int(size)
#         print self.articles[path][column]
#         self.articles[path][column]*=size
        model.set_value(iter, column, self.articles[path][column])
        

class MainWindow(Window):
    shapex=3
    shapey=3
    shapewidth=9
    shapeheight=9
    shape=[[0,0]]
    used=[[True]*9 for i in range(9)]
    entries=[[None]*9 for i in range(9)]
    
    ignore=False
    undoes=[]
    redoes=[]

    changed=False
    
    puzzle_actions = ActionGroup("Puzzle Actions")
    redo_action = ActionGroup("Redo")
    undo_action = ActionGroup("Undo")
    
    def shape_changed(self):
        minx = min([a for a,b in self.shape])
        miny = min([b for a,b in self.shape])
        for i in self.shape:
            i[0]-=minx
            i[1]-=miny
        self.shapewidth=max([a for a,b in self.shape])+self.shapex*self.shapey
        self.shapeheight=max([b for a,b in self.shape])+self.shapex*self.shapey
        self.used=[[False for i in range(self.shapeheight)] for j in range(self.shapewidth)]
        self.entries=[[None for i in range(self.shapeheight)] for j in range(self.shapewidth)]
        for x,y in self.shape:
            for i in range(x,x+(self.shapex*self.shapey)):
                for j in range(y,y+(self.shapex*self.shapey)):
                    self.used[i][j]=True
        self.shape = [[r,s] for r,s in set([(a,b) for a,b in self.shape])]
            
        self.changed=False
        undoes=[]
        redoes=[]
        self.undo_action.set_sensitive(False)
        self.redo_action.set_sensitive(False)
        self.box.remove(self.asp)
        sudoku = Table(self.shapeheight/self.shapey,self.shapewidth/self.shapex,True)
        sudoku.set_row_spacings(10)
        sudoku.set_col_spacings(10)
        entsize=1
        if self.shapex*self.shapey > 26:
            entsize=2
        for x in range(self.shapewidth/self.shapex):
            for y in range(self.shapeheight/self.shapey):
                curr = Table(self.shapey,self.shapex,True)
                sudoku.attach(colourWidget(curr,"gray90"),x,x+1,y,y+1)
                for i in range(self.shapex):
                    for j in range(self.shapey):
                        if self.used[x*self.shapex+i][y*self.shapey+j]==False:
                            continue
                        ent = Entry(entsize)
                        ent.set_size_request(20,20)
                        self.entries[x*self.shapex+i][y*self.shapey+j]=ent
                        ent.firsttime=True
                        def changer(e,a,b,c,undoes,action):
                            self.changed=True
                            if e.firsttime:
                                undoes.append((e,""))
                                action.set_sensitive(True)
                                e.firsttime=False
                        ent.connect("insert_text", changer, self.undoes,self.undo_action) 
                        ent.connect("delete_text", self.change)
                        al = Alignment(0.5,0.5)
                        al.add(ent)
                        curr.attach(al,i,i+1,j,j+1)
        self.asp = AspectFrame(None, obey_child=False)
        self.asp.add(colourWidget(sudoku,"black"))
        self.box.pack_start(self.asp,True,True,0)
        self.show_all()
        
    def quit_action(self,e):
        if not self.maybe_quit(e):
            main_quit()
    def new_sudoku(self,e):
        if self.maybe_quit(e):
            return
        self.filer.filename=None
        NewDialog(self)
    def maybe_quit(self,e,f=None):
        if self.changed:
            d=Dialog("Save Changes?",self,0,
                      (STOCK_CANCEL, RESPONSE_CANCEL,
                      "_Don't Save", RESPONSE_NO,
                      STOCK_YES, RESPONSE_YES))
            hbox=HBox(False,8)
            hbox.set_border_width(8)
            hbox.pack_start(image_new_from_stock(STOCK_DIALOG_QUESTION,ICON_SIZE_DIALOG),
                            False,False,0)
            hbox.pack_start(Label("Save changes to Su Doku?"))
            d.vbox.pack_start(hbox)
            d.show_all()
            val = d.run()
            d.destroy()
            if val==RESPONSE_YES:
                return self.save(False)
            elif val==RESPONSE_NO:
                return False
            else:
                return True
        else: return False
    
    def about(self,e):
       d=MessageDialog(self,0,MESSAGE_INFO,BUTTONS_OK,"Copyright 2005 Stephen Dolan")
       d.run()
       d.destroy()

    def save(self,saveas):
        if saveas or self.filer.filename==None:
            dialog = FileChooserDialog("Save..",
                                       self,
                                       FILE_CHOOSER_ACTION_SAVE,
                                       (STOCK_CANCEL,RESPONSE_CANCEL,
                                        STOCK_SAVE,RESPONSE_OK))
            dialog.set_default_response(RESPONSE_OK)
            
            filter = FileFilter()
            filter.set_name("Su Doku puzzles")
            filter.add_pattern("*.sudoku")
            dialog.add_filter(filter)
            if dialog.run() != RESPONSE_OK:
                dialog.destroy()
                return True
            self.filer.filename=dialog.get_filename()
            dialog.destroy()

        
        try:
            self.filer.save()
        except ValueError , x:
            d=MessageDialog(self,0,MESSAGE_ERROR,BUTTONS_OK,str(x))
            d.run()
            d.destroy()
            return True
        except IOError , (errno, x):
            d=MessageDialog(self,0,MESSAGE_ERROR,BUTTONS_OK,str(x))
            d.run()
            d.destroy()
            return True
        return False
            
    def openfile(self,c):
        dialog = FileChooserDialog("Open..",
                                   self,
                                   FILE_CHOOSER_ACTION_OPEN,
                                   (STOCK_CANCEL,RESPONSE_CANCEL,
                                    STOCK_OPEN,RESPONSE_OK))
        dialog.set_default_response(RESPONSE_OK)
            
        filter = FileFilter()
        filter.set_name("Su Doku puzzles")
        filter.add_pattern("*")
        dialog.add_filter(filter)
        if dialog.run() != RESPONSE_OK:
            dialog.destroy()
            return
        self.filer.filename=dialog.get_filename()
        dialog.destroy()
        self.opener()
    def opener(self):
        try:
            self.filer.openfile()
        except:
            d=MessageDialog(self,0,MESSAGE_ERROR,BUTTONS_OK,"Could not open file")
            d.run()
            d.destroy()            
        
    def change(self, e,b,c):
        self.changed=True
        if self.ignore: return
        self.undoes.append((e,e.get_text()))
        self.redoes=[]
        self.redo_action.set_sensitive(False)
        self.undo_action.set_sensitive(True)
    def undo(self, unused,undoes,redoes,targaction1,targaction2):
        e,text = undoes.pop()
        redoes.append((e,e.get_text()))
        self.ignore=True
        e.set_text(text)
        e.grab_focus()
        self.ignore=False
        targaction2.set_sensitive(True)
        if len(undoes)==0: targaction1.set_sensitive(False)
        if len(self.undoes)==0: self.changed=False


    def grabtext(self,text):
        try:
            text=text.strip()
            if text=="": return "00"
            if self.shapex*self.shapey < 10:
                i = int(text)
                if i>9: raise ValueError
                return "0"+str(i)
            elif self.shapex*self.shapey <= 26:
                i = ord(text)-ord('a')
                if i < 0:
                    i = ord(text)-ord('A')
                if i < 0:
                    raise ValueError
                i+=1
                return str(i).rjust(2,"0")
            else:
                i = int(text)
                return str(i).rjust(2,"0")
        except ValueError, TypeError:
            raise ValueError, '"'+text+'" is not a valid value'

    def parsetext(self,num):
        if num==0: return ""
        if self.shapex*self.shapey < 10:
            return str(num)
        elif self.shapex*self.shapey <=26:
            return chr(ord('A')+num-1)
        else:
            return str(num)
    def gen_puz(self):
        data = [[0 for y in x] for x in self.entries]
        known = [[False for y in x] for x in self.entries]
        for x in range(len(self.entries)):
            for y in range(len(self.entries[x])):
                if not self.used[x][y]:continue
                data[x][y]=int(self.grabtext(self.entries[x][y].get_text()))
                if data[x][y]!=0:
                    known[x][y]=True
        return Puzzle(self.shape,self.shapewidth,self.shapeheight,self.used,
                      self.shapex,self.shapey,data,known)
    
    def give_hint(self,widget):
        try:
            p = self.gen_puz()
        except ValueError , x:
            d=MessageDialog(self,0,MESSAGE_ERROR,BUTTONS_OK,str(x))
            d.run()
            d.destroy()
            return
        if p.findNextSolution():
            if p.firstCell!=None:
                x,y=p.firstCell
                self.entries[x][y].set_text(self.parsetext(p.data[x][y].value()))
            else:
                d=MessageDialog(self,0,MESSAGE_INFO,BUTTONS_OK,
                            "No hint to give")
                d.run()
                d.destroy()
        else:
            d=MessageDialog(self,0,MESSAGE_ERROR,BUTTONS_OK,
                            "No solutions. Try clicking Undo a few times")
            d.run()
            d.destroy()
    def solve(self,widget):
        try:
            p = self.gen_puz()
        except ValueError , x:
            d=MessageDialog(self,0,MESSAGE_ERROR,BUTTONS_OK,str(x))
            d.run()
            d.destroy()
            return

        if p.findNextSolution():
            for i in range(len(p.data)):
                for j in range(len(p.data[i])):
                    self.entries[i][j].set_text(self.parsetext(p.data[i][j].value()))
        else:
            d=MessageDialog(self,0,MESSAGE_ERROR,BUTTONS_OK,
                            "No solutions. Try clicking Undo a few times")
            d.run()
            d.destroy()
            
        
    def __init__(self,parent=None):
        Window.__init__(self)
        try:
            self.set_screen(parent.get_screen())
        except AttributeError:
            self.connect('destroy', lambda *w: main_quit())
        self.set_title("Su Doku")
        self.set_border_width(0)
#        self.set_size_request(-1,-1)
        self.connect("delete_event", self.maybe_quit)

        self.filer=FileHandler(self)
        entries = (
          ( "FileMenu", None, "_File" ),
          ( "EditMenu", None, "_Edit" ),
          ( "PuzzleMenu", None, "_Puzzle"),
          ( "HelpMenu", None, "_Help" ),
          ( "New", STOCK_NEW,
            "_New", "<control>N",
            "Create a new Su Doku",
            self.new_sudoku ),
          ( "Open", STOCK_OPEN,
            "_Open","<control>O",
            "Open a Su Doku",
            self.openfile ),
          ( "Save", STOCK_SAVE,
            "_Save","<control>S",
            "Save current Su Doku",
            lambda x:self.save(False) ),
          ( "SaveAs", STOCK_SAVE,
            "Save _As...", None,
            "Save to a file",
            lambda x:self.save(True)  ),
          ( "Quit", STOCK_QUIT,
            "_Quit", "<control>Q",
            "Quit",
            self.quit_action ),
          ( "About", STOCK_ABOUT,
            "_About", "<control>A",
            "About",
            self.about )
        )
        puzzle_entries = (
          ( "Next", STOCK_HELP,
            "_Hint", None,
            "Give next number",
            self.give_hint),
          ( "Solve", STOCK_APPLY,
            "_Solve", None,
            "Solve puzzle completely",
            self.solve),
        )
        undo_entry = (
          ("Undo", STOCK_UNDO,
             "_Undo", "<control>Z",
             "Undo last change",
             self.undo ),
        )
        redo_entry = (
          ("Redo", STOCK_REDO,
             "_Redo", "<control><shift>Z",
             "Redo last change",
             self.undo),
        )

        ui_info = \
        '''<ui>
            <menubar name='MenuBar'>
                <menu action='FileMenu'>
                    <menuitem action='New'/>
                    <menuitem action='Open'/>
                    <menuitem action='Save'/>
                    <menuitem action='SaveAs'/>
                    <separator/>
                    <menuitem action='Quit'/>
                </menu>
                <menu action='EditMenu'>
                    <menuitem action='Undo'/>
                    <menuitem action='Redo'/>
                </menu>
                <menu action='PuzzleMenu'>
                    <menuitem action='Next'/>
                    <menuitem action='Solve'/>
                </menu>
                <menu action='HelpMenu'>
                    <menuitem action='About'/>
                </menu>
            </menubar>
            <toolbar name='ToolBar'>
                <toolitem action='Next'/>
                <toolitem action='Solve'/>
            </toolbar>
        </ui>''' 
        actions = ActionGroup("Actions")
        actions.add_actions(entries)
        self.puzzle_actions.add_actions(puzzle_entries)
        self.puzzle_actions.set_sensitive(True)
        self.redo_action.add_actions(redo_entry, (self.redoes, self.undoes, self.redo_action,self.undo_action))
        self.redo_action.set_sensitive(False)
        self.undo_action.add_actions(undo_entry, (self.undoes, self.redoes, self.undo_action,self.redo_action))
        self.undo_action.set_sensitive(False)

        ui = UIManager()
        ui.insert_action_group(actions, 0)
        ui.insert_action_group(self.puzzle_actions,1)
        ui.insert_action_group(self.undo_action,3)
        ui.insert_action_group(self.redo_action,2)
        self.add_accel_group(ui.get_accel_group())

        try:
            mergeid = ui.add_ui_from_string(ui_info)
        except gobject.GError, msg:
            print "building menus failed: %s" % msg

        self.box = VBox(False, 0)
        self.add(self.box)
        self.box.pack_start(ui.get_widget("/MenuBar"),False,False,0)
        self.box.pack_start(ui.get_widget("/ToolBar"),False,False,0)

        self.asp = VBox()
        self.box.pack_start(self.asp,True,True,0)
        self.shape_changed()
        
        self.show_all()

if __name__=='__main__':
    a=MainWindow()
    if len(sys.argv)>1:
        a.filer.filename=sys.argv[1]
        a.opener()
    main()


