from classes import *
from copy import *
import sys

class Puzzle:
    def __init__(self,s,width,height,used,sizex,sizey,data,known):
        self.num=1
        self.firstCell=None
        self.first=True
        self.shape=s
        self.width=width
        self.height=height
        self.gridx=sizex
        self.gridy=sizey
        self.grid_2=sizex*sizey
        self.solved=False
        self.known=known
        self.data=[[Cell(self.grid_2,j,i) for i in range(self.height)] for j in range(self.width)]
        for x in range(self.width):
            for y in range(self.height):
                if data[x][y]==0:
                    self.data[x][y].couldContain=[True]*self.grid_2
                else:
                    self.data[x][y].couldContain=[False]*self.grid_2
                    self.data[x][y].couldContain[data[x][y]-1]=True
        self.used=used
        self.back=set()
        self.front=set()
        self.datas=[]
        for x,y in self.shape:
            for curr in range(self.grid_2):
                self.front.add(ConstraintRegion([self.data[x+i][y+curr] for i in range(0,self.grid_2)],self))
                self.front.add(ConstraintRegion([self.data[x+curr][y+i] for i in range(0,self.grid_2)],self))
                xoff = (curr%self.gridx)*self.gridx
                yoff = (curr/self.gridy)*self.gridy
                self.front.add(ConstraintRegion([self.data[xoff+x+i][yoff+y+j]
                                  for i in range(0,self.gridx)
                                  for j in range(0,self.gridy)],self))

    def findNextSolution(self):
        guess=0
        if self.completed() and self.solved:
            if not self.advance():
                return False
        while True:
            self.solve()
            if not self.seemsValid():
                if not self.advance():
                    return False
            elif not self.completed():
                guess+=1
                val=0
                indices=[(-1,-1)]*(self.grid_2-1)
                for x in range(len(self.data)):
                    for y in range(len(self.data[x])):
                        nposs = reduce(lambda a,b:a+b, self.data[x][y].couldContain)
                        if nposs >1:
                            indices[nposs-2]=(x,y)
                            if nposs == 2: break
                    else:
                        continue
                    break
                for i in indices:
                    if i==(-1,-1):continue
                    xindex,yindex=i
                    break
                for i in range(self.grid_2):
                    if self.data[xindex][yindex].couldContain[i]:
                        val=i
                        break
                copydata=[[copy(i.couldContain) for i in j] for j in self.data]
                self.datas.append((copydata,xindex,yindex,val,self.first))
                self.data[xindex][yindex].couldContain=[False]*self.grid_2
                self.data[xindex][yindex].couldContain[val]=True
                self.update(self.data[xindex][yindex])
            else:
                return True

    def advance(self):
        while True:
            if self.datas == []:
                return False
            conts,xindex,yindex,val,self.first = self.datas.pop()
            for i in range(len(conts)):
                for j in range(len(conts[i])):
                    self.data[i][j].couldContain=conts[i][j]
            done=False
            for i in range(val+1, self.grid_2):
                if self.data[xindex][yindex].couldContain[i]:
                    val=i
                    done=True
                    break
            if done:
                self.data[xindex][yindex].couldContain=[False]*self.grid_2
                self.data[xindex][yindex].couldContain[val]=True
                self.update(self.data[xindex][yindex])
                self.datas.append((conts,xindex,yindex,val,self.first))
                break
            else:
                conts,xindex,yindex,val,self.first=self.datas.pop()
        return True
                    
    def solve(self):
        self.solved=True
        x=0
        while True:
            x+=1
            self.back = self.front
            self.front=set()
            if self.back==set():
                break
            for i in self.back:
                i.analyze()
            

    def update(self, c):
        if self.first == True and not self.known[c.x][c.y]:
            val = reduce(lambda x,y:x+y, c.couldContain)
            
            if val == 1:
                self.firstCell=c.x,c.y
                self.first=False
        for i in c.constraints:
            self.front.add(i)

    def seemsValid(self):
        for i in range(len(self.data)):
            for j in range(len(self.data[i])):
                if self.used[i][j]==False: continue
                if not True in self.data[i][j].couldContain:
                    return False
        return True

    def completed(self):
        for i in range(len(self.data)):
            for j in range(len(self.data[i])):
                if self.used[i][j]==False: continue
                if reduce(lambda x,y: x+y, self.data[i][j].couldContain) != 1:
                    return False
        return True
    
